VERSION 5.00
Begin VB.Form frmClipx 
   Caption         =   "Clipboard Hexdumper"
   ClientHeight    =   6465
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10860
   ScaleHeight     =   6465
   ScaleWidth      =   10860
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdDrop 
      Caption         =   "Clip/Drop"
      Height          =   975
      Left            =   120
      Picture         =   "clipx.frx":0000
      Style           =   1  'Graphical
      TabIndex        =   3
      Top             =   120
      Width           =   975
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear"
      Height          =   975
      Left            =   1200
      Picture         =   "clipx.frx":0442
      Style           =   1  'Graphical
      TabIndex        =   2
      Top             =   120
      Width           =   975
   End
   Begin VB.TextBox txtDumper 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   6255
      Left            =   2280
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   120
      Width           =   8535
   End
   Begin VB.ListBox lstFormats 
      Height          =   4935
      Left            =   120
      Sorted          =   -1  'True
      TabIndex        =   0
      Top             =   1200
      Width           =   2055
   End
End
Attribute VB_Name = "frmClipx"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' ATL wrapper used for catching OleDragDrop operations
' on the control cmdDrop
Private WithEvents oBinder As ATLBINDLib.Binder
Attribute oBinder.VB_VarHelpID = -1

Private Sub Form_Load()
  ' create an instance of the binder
  Set oBinder = New ATLBINDLib.Binder
  ' bind the binder to the cmdDrop control
  oBinder.Bind cmdDrop.hWnd
End Sub

' event raised by the binder after something
' has been dropped on the bound control
Private Sub oBinder_OnDrop(ByVal Formats As String)
  ' all supported formats sent along in this string (unused)
  Debug.Print Formats
  ' data already placed on clipboard by the binder
  ' - just forward call to the click event handler
  cmdDrop_Click
End Sub

' clear the clipboard, format selector and dumper
Private Sub cmdClear_Click()
  Clipboard.Clear
  txtDumper.Text = ""
  lstFormats.Clear
End Sub

' dump all formats of the clipboard into to the format selector listbox
Private Sub cmdDrop_Click()
  Dim nFmt As Long
  
  ' clear the listbox
  lstFormats.Clear
  
  ' open the clipboard
  If OpenClipboard(0) = 0 Then Exit Sub
  
  nFmt = 0
  Do
    ' get next clipboard format
    nFmt = EnumClipboardFormats(nFmt)
    ' exit if nomore available
    If nFmt = 0 Then Exit Do
    ' add formatidentifier and name to the list box
    lstFormats.AddItem fhex(nFmt, 4) & " - " & GetClipFormatName(nFmt)
    ' set itemdata to clipboard format identifier
    lstFormats.ItemData(lstFormats.NewIndex) = nFmt
  Loop While True
  
  ' close the clipboard
  CloseClipboard
End Sub

' the user clicked on a format
' extract the clipboard data and display hex/ascii dump
Private Sub lstFormats_Click()
  Dim FormatID As Long
  Dim idx As Long
  
  ' get currently selected format
  idx = lstFormats.ListIndex
  FormatID = lstFormats.ItemData(idx)
  txtDumper.Text = lstFormats.List(idx)

  Dim hndData As Long
  Dim hndLock As Long
  Dim DataSize As Long
  Dim DataBytes() As Byte
  
  On Error GoTo lbl_err
  
  ' get clipboard access
  If OpenClipboard(0) = 0 Then Err.Raise 111, , "cannot open clipboard"
  
  ' get handle to contents
  hndData = GetClipboardData(FormatID)
  If hndData = 0 Then Err.Raise 112, , "cannot extract clipboarddata of format " & FormatID & ", err=" & Err.LastDllError
  
  ' check size
  DataSize = GlobalSize(hndData)
  If DataSize > 0 Then
    ' allocate room for the data
    ReDim DataBytes(0 To DataSize - 1)
    
    ' lock the data
    hndLock = GlobalLock(hndData)
    
    ' copy global memory into local byte array
    CopyMemory DataBytes(0), ByVal hndLock, DataSize
      
    ' remove lock from global data
    GlobalUnlock hndData
  End If
  
  ' dump hex/ascii text
  txtDumper.Text = txtDumper.Text & vbCrLf & "Size=" & DataSize & vbCrLf & ByteArrayToHex(DataBytes)

lbl_exit:
  ' close clipboard
  CloseClipboard
  
  Exit Sub

lbl_err:
  txtDumper.Text = txtDumper.Text & vbCrLf & "ERROR: " & Err.Number & " - " & Err.Description
  Resume lbl_exit
End Sub

' boreing form resizer code
Private Sub Form_Resize()
  Const DX = 200
  Const DY = 500
  Static isresizing As Boolean
  If isresizing Then Exit Sub
  isresizing = True
  If Width < txtDumper.Left + 10 * DX Then Width = txtDumper.Left + 10 * DX
  If Height < txtDumper.top + 10 * DY Then Height = txtDumper.top + 10 * DY
  txtDumper.Width = Width - txtDumper.Left - DX
  txtDumper.Height = Height - txtDumper.top - DY
  lstFormats.Height = Height - lstFormats.top - DY
  isresizing = False
End Sub

Private Sub Form_Unload(Cancel As Integer)
  ' stop binding the cmdDrop control
  oBinder.Unbind
  ' remove instance of the binder
  Set oBinder = Nothing
End Sub

