// Binder.h : Declaration of the CBinder

#ifndef __BINDER_H_
#define __BINDER_H_

#include "resource.h"       // main symbols
#include "atlBindCP.h"

/////////////////////////////////////////////////////////////////////////////
// CBinder
class ATL_NO_VTABLE CBinder : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CBinder, &CLSID_Binder>,
	public IConnectionPointContainerImpl<CBinder>,
	public IDispatchImpl<IBinder, &IID_IBinder, &LIBID_ATLBINDLib>,
	public IDropTarget,
	public CProxy_ICBinderEvents< CBinder >
{
public:
	
	CBinder()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_BINDER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CBinder)
	COM_INTERFACE_ENTRY(IBinder)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(CBinder)
CONNECTION_POINT_ENTRY(DIID__ICBinderEvents)
END_CONNECTION_POINT_MAP()

// IBinder
public:
	STDMETHOD(get_Result)(/*[out, retval]*/ BSTR *pVal);
	HWND m_hwnd;
	STDMETHOD(Unbind)();
	STDMETHOD(Bind)(long hwnd);
	_bstr_t bstrResult;

  CComPtr<IDropTargetHelper> m_DropHelper;	// Drop target helper
  CComPtr<IDataObject> m_DragObject; // The object being dragged


	virtual HRESULT STDMETHODCALLTYPE DragEnter( 
		/* [unique][in] */ IDataObject __RPC_FAR *pDataObj,
		/* [in] */ DWORD grfKeyState,
		/* [in] */ POINTL pt,
		/* [out][in] */ DWORD __RPC_FAR *pdwEffect) ;

	virtual HRESULT STDMETHODCALLTYPE DragOver( 
		/* [in] */ DWORD grfKeyState,
		/* [in] */ POINTL pt,
		/* [out][in] */ DWORD __RPC_FAR *pdwEffect) ;

	virtual HRESULT STDMETHODCALLTYPE DragLeave( void) ;

	virtual HRESULT STDMETHODCALLTYPE Drop( 
		/* [unique][in] */ IDataObject __RPC_FAR *pDataObj,
		/* [in] */ DWORD grfKeyState,
		/* [in] */ POINTL pt,
		/* [out][in] */ DWORD __RPC_FAR *pdwEffect);


};

#endif //__BINDER_H_
